coverity:
  image: thetorproject/tor-ci-debian:testing
  tags:
    # We can only use x86-64 runners for the Coverity binaries.
    - amd64
  only:
    # This only works via schedules since the variables aren't passed from the
    # vault otherwise.
    - schedules

  script:
    # Clone Tor.
    - git clone https://gitlab.torproject.org/tpo/core/tor.git
    - cd tor

    # Fetch Coverity utlities.
    - curl -o /tmp/cov-analysis-linux64.tgz https://scan.coverity.com/download/linux64 --form project=$COVERITY_SCAN_PROJECT_NAME --form token=$COVERITY_SCAN_TOKEN
    - tar xfz /tmp/cov-analysis-linux64.tgz

    # Debug.
    # - git describe --always
    # - exit 1

    # Prepare the directory structure.
    - mkdir cov-int

    # Configure Tor.
    - ./autogen.sh
    - cov-analysis-linux64-*/bin/cov-build --dir cov-int ./configure

    # Pre-define some float types. This is needed because of an issue with
    # Coverity's headers.
    - echo "#define _Float128 double" >> orconfig.h
    - echo "#define _Float64 double" >> orconfig.h
    - echo "#define _Float64x double" >> orconfig.h
    - echo "#define _Float32 float" >> orconfig.h
    - echo "#define _Float32x float" >> orconfig.h

    # Build Tor.
    - cov-analysis-linux64-*/bin/cov-build --dir cov-int make -j$(nproc)

    # Pack up the build and submit it to Coverity.
    - tar cfz cov-int.tar.gz cov-int
    - curl https://scan.coverity.com/builds?project=$COVERITY_SCAN_PROJECT_NAME --form token=$COVERITY_SCAN_TOKEN --form email=ahf@torproject.org --form file=@cov-int.tar.gz --form version="`git describe`" --form description="$CI_PIPELINE_ID"
